;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; IDEBar v1.2 - Appbar.asm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; General functions to create and manage the AppBar
; Most code directly converted from the appbar example in MSDN
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;-------------------------------------------------------------------------------
; PROTOTYPES
;-------------------------------------------------------------------------------
NewAppBar 				PROTO STDCALL	:DWORD, :DWORD
KillAppBar				PROTO STDCALL	:DWORD
SendAppBarWinPosChange 	PROTO STDCALL 	:DWORD
SendAppBarActive		PROTO STDCALL 	:DWORD
SuggestScreenRect		PROTO STDCALL 	:DWORD, :DWORD, :DWORD
SetAppBarPos			PROTO STDCALL 	:DWORD, :DWORD, :DWORD

.code
;-------------------------------------------------------------------------------
; NewAppBar
;-------------------------------------------------------------------------------
; Returns 0 on failure, 1 on success
;
NewAppBar	proc	hWnd:DWORD, CallBackMsg:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	CallBackMsg
	pop		abd.uCallbackMessage
	push	hWnd
	pop		abd.hwnd
	invoke	SHAppBarMessage, ABM_NEW, ADDR abd
ret
NewAppBar	endp

;-------------------------------------------------------------------------------
; Kill AppBar
;-------------------------------------------------------------------------------
;always returns true (due to ABM_REMOVE)
KillAppBar	proc	hWnd:DWORD

LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	hWnd
	pop		abd.hwnd
	invoke	SHAppBarMessage, ABM_REMOVE, ADDR abd
ret
KillAppBar	endp

;-------------------------------------------------------------------------------
; Suggest screen rect
;-------------------------------------------------------------------------------
; suggests a screen rect to the appbar
; always returns true (due to ABM_QUERYPOS)
SuggestScreenRect	proc	hWnd:DWORD, lpRC:DWORD, uEdge:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	uEdge
	pop		abd.uEdge
	push	hWnd
	pop		abd.hwnd
	mov		ecx, lpRC
	mov		eax, [ecx]	
	mov		abd.rc.left, eax
	mov		eax, [ecx+4]	
	mov		abd.rc.top, eax
	mov		eax, [ecx+8]	
	mov		abd.rc.right, eax
	mov		eax, [ecx+12]	
	mov		abd.rc.bottom, eax
	invoke	SHAppBarMessage, ABM_QUERYPOS, ADDR abd
	mov		ecx, lpRC
	mov		eax, abd.rc.left
	mov		[ecx], eax
	mov		eax, abd.rc.top
	mov		[ecx+4], eax
	mov		eax, abd.rc.right
	mov		[ecx+8], eax
	mov		eax, abd.rc.bottom
	mov		[ecx+12], eax	
	xor		eax, eax ;restore result of ABM_QUERYPOS
	inc		eax
ret
SuggestScreenRect	endp
;-------------------------------------------------------------------------------
; SetAppBarPos
;-------------------------------------------------------------------------------
;always returns true due to ABM_SETPOS
SetAppBarPos		proc	hWnd:DWORD, lpRC:DWORD, uEdge:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	uEdge
	pop		abd.uEdge
	push	hWnd
	pop		abd.hwnd
	mov		ecx, lpRC
	mov		eax, [ecx]	
	mov		abd.rc.left, eax
	mov		eax, [ecx+4]	
	mov		abd.rc.top, eax
	mov		eax, [ecx+8]	
	mov		abd.rc.right, eax
	mov		eax, [ecx+12]	
	mov		abd.rc.bottom, eax
	

	invoke	SHAppBarMessage, ABM_SETPOS, ADDR abd
	mov		ecx, lpRC
	mov		eax, abd.rc.left
	mov		[ecx], eax
	mov		eax, abd.rc.top
	mov		[ecx+4], eax
	mov		eax, abd.rc.right
	mov		[ecx+8], eax
	mov		eax, abd.rc.bottom
	mov		[ecx+12], eax	
	xor		eax, eax ;restore result of ABM_SETPOS
	inc		eax
ret
SetAppBarPos		endp

;-------------------------------------------------------------------------------
; SendAppBarActive
;-------------------------------------------------------------------------------
SendAppBarActive	proc	hWnd:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	hWnd
	pop		abd.hwnd
	invoke	SHAppBarMessage, ABM_ACTIVATE, ADDR abd
ret
SendAppBarActive	endp

;-------------------------------------------------------------------------------
; Send AppBar window position change
;-------------------------------------------------------------------------------
SendAppBarWinPosChange	proc	hWnd:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	hWnd
	pop		abd.hwnd
	invoke	SHAppBarMessage, ABM_WINDOWPOSCHANGED, ADDR abd
ret
SendAppBarWinPosChange	endp

